#if !defined(AFX_FFT1024CTL_H__771A90AA_C289_4BE8_9B24_49111CDC40AB__INCLUDED_)
#define AFX_FFT1024CTL_H__771A90AA_C289_4BE8_9B24_49111CDC40AB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define FIX_MPY(DEST,A,B)       DEST = ((long)(A) * (long)(B))>>15

#define N_WAVE          1024    /* dimension of Sinewave[] */
#define LOG2_N_WAVE     10      /* log2(N_WAVE) */
#define N_LOUD          100     /* dimension of Loudampl[] */

#ifndef fixed
#define fixed short
#endif

// FFT1024Ctl.h : Declaration of the CFFT1024Ctrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CFFT1024Ctrl : See FFT1024Ctl.cpp for implementation.

class CFFT1024Ctrl : public COleControl
{
	DECLARE_DYNCREATE(CFFT1024Ctrl)

private:
	fixed fr[1024];
	fixed fi[1024];
	fixed loud[1024];
    

	int fix_fft(fixed fr[], fixed fi[], int m, int inverse); 
	void window(fixed fr[], int n);
	BOOL bFFTWindow;
	short idxMax;
	short iPowerScaler;
	void fix_loud(fixed loud[], fixed fr[], fixed fi[], int n);
	int db_from_ampl(fixed re, fixed im);
	fixed fix_mpy(fixed a, fixed b);

// Constructor
public:
	CFFT1024Ctrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFFT1024Ctrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CFFT1024Ctrl();

	DECLARE_OLECREATE_EX(CFFT1024Ctrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CFFT1024Ctrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CFFT1024Ctrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CFFT1024Ctrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CFFT1024Ctrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CFFT1024Ctrl)
	afx_msg BOOL GetFFTWindow();
	afx_msg void SetFFTWindow(BOOL bNewValue);
	afx_msg short GetPowerScaler();
	afx_msg void SetPowerScaler(short nNewValue);
	afx_msg void Waveform(const VARIANT FAR& data);
	afx_msg VARIANT Power();
	afx_msg void SetWaveformPt(short idx, short data);
	afx_msg short GetPowerPt(short idx);
	afx_msg void FFTNow(short size);
	afx_msg short GetPeakIdx();
	afx_msg short GetRe(short idx);
	afx_msg short GetIm(short idx);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CFFT1024Ctrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CFFT1024Ctrl)
	dispidFFTWindow = 1L,
	dispidPowerScaler = 2L,
	dispidWaveform = 3L,
	dispidPower = 4L,
	dispidSetWaveformPt = 5L,
	dispidGetPowerPt = 6L,
	dispidFFTNow = 7L,
	dispidGetPeakIdx = 8L,
	dispidGetRe = 9L,
	dispidGetIm = 10L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FFT1024CTL_H__771A90AA_C289_4BE8_9B24_49111CDC40AB__INCLUDED)
